"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_client_1 = require("@ffflorian/api-client");
var api_1 = require("./api");
var LibrariesIO = /** @class */ (function () {
    function LibrariesIO(options) {
        var _this = this;
        if (typeof options === 'string') {
            options = { apiKey: options };
        }
        this.options = __assign({ apiUrl: 'https://libraries.io/api' }, options);
        var requestInjector = function (config) {
            config.data = __assign({}, config.data, { api_key: _this.options.apiKey });
            return config;
        };
        // const responseInjector = (response: AxiosResponseWithoutData<LibrariesIOHeaders>) => {
        //   const headers = response.headers;
        //   const contentType = headers['content-type'] ? String(headers['content-type']) : undefined;
        //   const rateLimit = Number(headers['x-ratelimit-limit']);
        //   const rateLimitRemaining = Number(headers['x-ratelimit-remaining']);
        //   const totalResults = headers['total'] ? Number(headers['total']) : undefined;
        //   return {...response, d: 2}
        // }
        this.apiClient = new api_client_1.APIClient({
            apiUrl: this.options.apiUrl,
            requestInjector: requestInjector,
        });
        this.api = {
            github: {
                repository: new api_1.GitHubRepositoryAPI(this.apiClient, this.options),
                user: new api_1.GitHubUserAPI(this.apiClient, this.options),
            },
            platform: new api_1.PlatformAPI(this.apiClient, this.options),
            project: new api_1.ProjectAPI(this.apiClient, this.options),
            user: new api_1.UserAPI(this.apiClient, this.options),
        };
    }
    /*
  
        const contentType = headers['content-type'] ? String(headers['content-type']) : undefined;
        const rateLimit = Number(headers['x-ratelimit-limit']);
        const rateLimitRemaining = Number(headers['x-ratelimit-remaining']);
        const totalResults = headers['total'] ? Number(headers['total']) : undefined;
    */
    /**
     * Set a new API URL.
     * @param newUrl The new API url
     */
    LibrariesIO.prototype.setApiUrl = function (newUrl) {
        this.apiClient.setApiUrl(newUrl);
    };
    /**
     * Set a new API key.
     * @param apiKey The new API key
     */
    LibrariesIO.prototype.setApiKey = function (apiKey) {
        this.options.apiKey = apiKey;
    };
    return LibrariesIO;
}());
exports.LibrariesIO = LibrariesIO;
//# sourceMappingURL=LibrariesIO.js.map