import { APIClient } from '@ffflorian/api-client';
import { ClientOptions, RequestOptions } from '../interfaces';
export declare class APIBase {
    protected readonly apiClient: APIClient<RequestOptions>;
    protected readonly options: ClientOptions;
    constructor(apiClient: APIClient, options: ClientOptions);
    protected checkApiKey(apiName?: string): void;
    /**
     * Set a new API URL.
     * @param newUrl The new API url
     */
    setApiUrl(newUrl: string): void;
    /**
     * Set a new API key.
     * @param apiKey The new API key
     */
    setApiKey(apiKey: string): void;
}
