"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var APIBase = /** @class */ (function () {
    function APIBase(apiClient, options) {
        this.apiClient = apiClient;
        this.options = options;
    }
    APIBase.prototype.checkApiKey = function (apiName) {
        apiName = "the \"" + apiName + "\"" || 'this';
        if (!this.options.apiKey) {
            throw new Error("An API key needs to be set in order to use " + apiName + " API");
        }
    };
    /**
     * Set a new API URL.
     * @param newUrl The new API url
     */
    APIBase.prototype.setApiUrl = function (newUrl) {
        this.apiClient.setApiUrl(newUrl);
    };
    /**
     * Set a new API key.
     * @param apiKey The new API key
     */
    APIBase.prototype.setApiKey = function (apiKey) {
        this.options.apiKey = apiKey;
    };
    return APIBase;
}());
exports.APIBase = APIBase;
//# sourceMappingURL=APIBase.js.map