"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Endpoints_1 = require("../../Endpoints");
var APIBase_1 = require("../APIBase");
var GitHubRepositoryAPI = /** @class */ (function (_super) {
    __extends(GitHubRepositoryAPI, _super);
    function GitHubRepositoryAPI(apiClient, options) {
        return _super.call(this, apiClient, options) || this;
    }
    /**
     * Get a info for a repository. Currently only works for open source repositories.
     * @see https://libraries.io/api#repository
     * @param repositoryOwner The repository owner
     * @param repositoryName The repository name
     */
    GitHubRepositoryAPI.prototype.getRepository = function (repositoryOwner, repositoryName) {
        var endpoint = Endpoints_1.Endpoint.GitHub.Repository.repository(repositoryOwner, repositoryName);
        return this.apiClient.requestService.get(endpoint);
    };
    /**
     * Get a list of dependencies for a repositories. Currently only works for open source repositories.
     * @see https://libraries.io/api#repository-dependencies
     * @param repositoryOwner The repository owner
     * @param repositoryName The repository name
     */
    GitHubRepositoryAPI.prototype.getRepositoryWithDependencies = function (repositoryOwner, repositoryName) {
        var endpoint = Endpoints_1.Endpoint.GitHub.Repository.dependencies(repositoryOwner, repositoryName);
        return this.apiClient.requestService.get(endpoint);
    };
    /**
     * Get a list of packages referencing the given repository.
     * @see https://libraries.io/api#repository-projects
     * @param repositoryOwner The repository owner
     * @param repositoryName The repository name
     * @param options Pagination Options
     */
    GitHubRepositoryAPI.prototype.getProjects = function (repositoryOwner, repositoryName, options) {
        var endpoint = Endpoints_1.Endpoint.GitHub.Repository.projects(repositoryOwner, repositoryName);
        return this.apiClient.requestService.get(endpoint, { data: options });
    };
    return GitHubRepositoryAPI;
}(APIBase_1.APIBase));
exports.GitHubRepositoryAPI = GitHubRepositoryAPI;
//# sourceMappingURL=GitHubRepositoryAPI.js.map